#! /bin/bash

error=0; trap 'error=$(($?>$error?$?:$error))' ERR # save maximum error code


newnicnames() {

    # determine predictable network names only for stretch and above

    [ $do_init_tasks -eq 0 ] && return
    [ -z "$NIC1" ] && return
    ver=$($ROOTCMD dpkg-query --showformat='${Version}' --show udev)
    if dpkg --compare-versions $ver lt 220-7; then
	return
    fi


    fields="ID_NET_NAME_FROM_DATABASE ID_NET_NAME_ONBOARD ID_NET_NAME_SLOT ID_NET_NAME_PATH"
    for field in $fields; do
	name=$(udevadm info /sys/class/net/$NIC1 | sed -rn "s/^E: $field=(.+)/\1/p")
	if [[ $name ]]; then
	    NIC1=$name
	    break
	fi
    done
    if [[ ! $name ]]; then
	echo "$0: error: could not find systemd predictable network name. Using $NIC1."
    fi
}

if [ -z "$NIC1" ]; then
    echo "WARNING: \$NIC1 is not defined. Cannot add ethernet to /etc/network/interfaces."
fi
CIDR=$(ip -o -f inet addr show $NIC1 | awk '{print $4}')
newnicnames
if ifclass DHCPC && [ $FAI_ACTION = "install" -o $FAI_ACTION = "dirinstall" ]; then

    cat > $target/etc/network/interfaces <<-EOF
	# generated by FAI
        # interfaces(5) file used by ifup(8) and ifdown(8)
        # Include files from /etc/network/interfaces.d:
        source-directory /etc/network/interfaces.d

        auto lo
	iface lo inet loopback

EOF
    if [ -n "$NIC1" ]; then
	cat >> $target/etc/network/interfaces <<-EOF
        auto $NIC1
	iface $NIC1 inet dhcp
EOF
    fi
elif [ $FAI_ACTION = "install" -o $FAI_ACTION = "dirinstall" ]; then
      [ -n "$CIDR" ] && cat > $target/etc/network/interfaces <<-EOF
	# generated by FAI
        # interfaces(5) file used by ifup(8) and ifdown(8)
        # Include files from /etc/network/interfaces.d:
        source-directory /etc/network/interfaces.d

        auto lo
	iface lo inet loopback

        auto $NIC1
	iface $NIC1 inet static
	  address $CIDR
	  gateway $GATEWAYS
EOF
    [ -n "$NETWORK" ] && echo "localnet $NETWORK" > $target/etc/networks
    if [ ! -L $target/etc/resolv.conf -a -e /etc/resolv.conf ]; then
	cp -p /etc/resolv.conf $target/etc
    fi
fi

# here fcopy is mostly used, when installing a client for running in a
# different subnet than during the installation
fcopy -iM /etc/resolv.conf
fcopy -iM /etc/network/interfaces /etc/networks

exit $error
